import gulp from 'gulp';
import util from 'gulp-util';
import connect from 'gulp-connect';
import browserify from 'browserify';
import babelify from 'babelify';
import source   from 'vinyl-source-stream';

gulp.task('compile-js', () => {
  browserify({ 
    entries: './src/app.jsx', 
    debug: true
  })
    .transform(babelify)
    .bundle(babelify)
    .on('error', (err) => {
      util.log(
        util.colors.red('Error'), 
        `${err.message}\n${err.codeFrame}`
      );
      gulp.emit('end');      
    })
    .pipe(source('app.js'))
    .pipe(gulp.dest('./dist/'));
});

gulp.task('watch', () => {
  gulp.watch(['./src/**/*'], ['compile-js']);
//  gulp.watch(['./dist/**/*.*', '!./public/**/*.js.map'], ['reload']);
});

gulp.task('connect', () => {
  connect.server({
    root: '.',
    livereload: true
  });
});

//gulp.task('reload', function () {
//  gulp.src(['./dist/**/*.*', '!./public/**/*.js.map'])
//      .pipe(connect.reload());
//});

gulp.task('default', ['watch', 'compile-js', 'connect']);
